class Mobile {
  PVector position, positionPrec, selectionRef;
  PVector force;
  float masse = 0.5; // Masse en kg
  color couleur;
  boolean selection = false;

  Mobile (PVector pos) {
    position = pos;
    positionPrec = pos;
    force = new PVector(0, 0);
    couleur = color(255);
  }

  void afficher() {
    fill(couleur);
    rect(position.x, position.y - 25, 50, 50);
  }

  void actualiser(float deltaT) {
    PVector temp = position.get(); // Intégration Verlet x(t+1) = 2 * x(t) - x(t-1) + a * T * T
    PVector calcul = PVector.mult(position, 2);
    PVector vitesse = PVector.div(PVector.sub(position, positionPrec), deltaT);
    calcul.sub(positionPrec);
    PVector acceleration = PVector.div(force, masse); // Loi de Newton : F = M * A
    acceleration.mult(deltaT * deltaT);
    calcul.add(acceleration);
    position = calcul.get();
    positionPrec = temp.get();
    if (position.x < 70) {
      position.x = 70; // Limite minimale de compression du ressort
    }
  }

  void select(PVector PMouse) {
    if ((PMouse.x > deplacement + position.x) && (PMouse.x < deplacement + position.x + 50) && (PMouse.y > deplacement + position.y - 25) && (PMouse.y < deplacement + position.y + 25)) {
      selection = true;
      selectionRef = PVector.sub(position, PMouse);
      couleur = color(100);
    }
  }

  void glisser(PVector PMouse) {
    if (selection) {
      position = PVector.add(selectionRef, PMouse);
      if (position.x  < 70) {
        position.x = 70;
      }
      position.y = -25;
    }
  }

  void deSelect() {
    selection = false;
    couleur = color(255);
  }
}

